package com.hoolai.demo.share;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.view.View;
import android.widget.Toast;
import com.hoolai.access.open.fastaccess.utils.Logger;
import com.hoolai.fastsdk.demo.R;
import com.hoolai.open.fastaccess.channel.FastSdk;
import com.hoolai.open.fastaccess.channel.callback.FacebookShareCallback;
import com.hoolai.open.fastaccess.channel.callback.FacebookShareType;
import com.hoolai.open.fastaccess.channel.pojo.FaceBookShareData;
import java.util.ArrayList;
import java.util.List;

/**
 * @author gaor
 * @date 2023/12/14 20:22
 * @description 分享
 */
public class ShareActivity extends Activity {

    private static int REQUEST_PHOTO_PICKER_SINGLE_SELECT = 1008611;
    private static int REQUEST_VIDEO_PICKER_SINGLE_SELECT = 1008612;
    private FacebookShareCallback facebookShare = new FacebookShareCallback() {
        @Override
        public void onSuccess(String s) {
            Toast.makeText(ShareActivity.this, "分享成功" + s, Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onCancel() {
            Toast.makeText(ShareActivity.this, "取消分享", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onError(String s) {
            Toast.makeText(ShareActivity.this, "分享失败" + s, Toast.LENGTH_SHORT).show();
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_share);

    }

    public void shareText(View view) {
        String title = "系统文字分享";
        String contentText = "分享内容";
        com.hoolai.open.fastaccess.channel.FastSdk.invokeSpecialFunction(112, title, contentText);
    }

    public void shareVideo(View view) {
        Intent intent = new Intent(MediaStore.ACTION_PICK_IMAGES);
        startActivityForResult(intent, REQUEST_VIDEO_PICKER_SINGLE_SELECT);
    }

    public void sharePhoto(View view) {
        Intent intent = new Intent(MediaStore.ACTION_PICK_IMAGES);
        startActivityForResult(intent, REQUEST_PHOTO_PICKER_SINGLE_SELECT);
    }

    public void fbShareText(View view) {
        FaceBookShareData data = new FaceBookShareData();
        data.setHashTag("#" + getAppName(this));
        data.setQuote("http://www.baidu.com");
        data.setUrl("http://www.baidu.com");
        FastSdk.facebookShare(FacebookShareType.LINK, data, facebookShare);
    }

    public void fbPhotoShare(View view) {
        Intent intent = new Intent(MediaStore.ACTION_PICK_IMAGES);
        startActivityForResult(intent, REQUEST_PHOTO_PICKER_SINGLE_SELECT);
    }

    public void fbShareVideo(View view) {
        Intent intent = new Intent(MediaStore.ACTION_PICK_IMAGES);
        startActivityForResult(intent, REQUEST_VIDEO_PICKER_SINGLE_SELECT);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (data == null) {
            return;
        }
        Uri uri = data.getData();
        if (uri == null) {
            return;
        }
        Logger.i("shareActivity onActivityResult:" + uri.toString());
        if (requestCode == REQUEST_PHOTO_PICKER_SINGLE_SELECT) {
           /* String title = "系统图片分享";
            com.hoolai.open.fastaccess.channel.FastSdk.invokeSpecialFunction(113, title, data1);*/

            //facebook图片分享
            FaceBookShareData faceBookShareData = new FaceBookShareData();
            List<String> listBitMap = new ArrayList<>();
            listBitMap.add(uri.toString());
            faceBookShareData.setHashTag("#demo");
            faceBookShareData.setBitMap(listBitMap);
            FastSdk.facebookShare(FacebookShareType.IMAGE, faceBookShareData, facebookShare);

        } else if (requestCode == REQUEST_VIDEO_PICKER_SINGLE_SELECT) {
            //系统分享视频
            //com.hoolai.open.fastaccess.channel.FastSdk.invokeSpecialFunction(115, "系统视频分享", uri);

            //Facebook视频分享
            FaceBookShareData faceBookShareData = new FaceBookShareData();
            faceBookShareData.setHashTag("#" + getAppName(this));
            faceBookShareData.setVideoPath(uri.toString());
            FastSdk.facebookShare(FacebookShareType.VIDEO, faceBookShareData, facebookShare);
        }
    }

    /**
     * 获取应用程序名称
     */
    public static synchronized String getAppName(Context context) {
        try {
            PackageManager packageManager = context.getPackageManager();
            PackageInfo packageInfo = packageManager.getPackageInfo(
                    context.getPackageName(), 0);
            int labelRes = packageInfo.applicationInfo.labelRes;
            return context.getResources().getString(labelRes);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
